\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{tikz-highlight}

\RequirePackage{etoolbox}
\RequirePackage{listings}
\RequirePackage{xcolor}

% Should be loaded last according to documentation
\RequirePackage{hyperref}

\definecolor{dark_green}{rgb}{0.00, 0.60, 0.00}
\definecolor{gray}{rgb}{0.50, 0.50, 0.50}
\definecolor{mauve}{rgb}{0.60, 0.00, 0.80}

\hypersetup{
	colorlinks,
	linkcolor=black,
	urlcolor=dark_green,
}

\lstdefinelanguage[LaTeX-TikZ]{TeX}[LaTeX]{TeX}{
	% Although not really "letters",
	% it must be added to this list for symbols
	% containing non-letters for highlighting to work properly
	alsoletter={
		\\,
		3,
	},
	commentstyle=\color{dark_green},
	keywords=[1]{
		\\addplot,
		\\addplot3,
		\\begin,
		\\clip,
		\\colorlet,
		\\coordinate,
		\\def,
		\\draw,
		\\end,
		\\fill,
		\\filldraw,
		\\foreach,
		\\graph,
		\\newcommand,
		\\node,
		\\path,
		\\pgfmathdeclarerandomlist,
		\\pgfmathrandomitem,
		\\pgfmathsetseed,
		\\pgfplotsset,
		\\shade,
		\\tikzset,
		\\usepgfplotslibrary,
		\\usetikzlibrary,
		in,
	},
	keywordstyle=[1]\bfseries\color{blue},
%
	keywords=[2]{
		arc,
		circle,
		coordinate,
		cycle,
		ellipse,
		fill,
		grid,
		node,
		rectangle,
	},
	keywordstyle=[2]\color{mauve},
%
	otherkeywords={
		--,
		->,
		|-
	},
	keywords=[3]{
		--,
		|-,
		->,
	},
	keywordstyle=[3]\color{dark_green},
%
	morestring=[s]{(}{)},
	stringstyle=\color{mauve!50},
}

\lstset{
	language={[LaTeX-TikZ]{TeX}},
	basicstyle={\color{gray}\ttfamily\linespread{1.25}\footnotesize},
%
	aboveskip=3mm,
	belowskip=3mm,
	breakatwhitespace=true,
	breaklines=true,
	columns=flexible,
	escapechar=`,
	frame=none,
	numbers=left,
	numberstyle=\tiny\color{gray},
	showstringspaces=false,
	tabsize=3,
}

% Allow using close parenthesis as ending token when breaklines=true
% From https://tex.stackexchange.com/a/74856
\makeatletter
\patchcmd{\lsthk@SelectCharTable}{%
	\lst@ifbreaklines\lst@Def{`)}{\lst@breakProcessOther)}\fi
}{}{}{}
\makeatother
